From b2d910af73e1d1d58acddcf5a47efadf34c8498d Mon Sep 17 00:00:00 2001
From: lixin <3531982712@qq.com>
Date: Mon, 27 May 2024 11:01:08 +0800
Subject: [PATCH 1/2] xenomai rt-linux patch, based on
 dovetail-core-5.10.161-on-rockchip-base-cae91899b

---
 kernel/Documentation/dovetail.rst             |   30 +
 kernel/Makefile                               |    2 +-
 kernel/arch/Kconfig                           |    3 +
 kernel/arch/arm/Kconfig                       |    9 +
 kernel/arch/arm/common/mcpm_entry.c           |   12 +-
 kernel/arch/arm/include/asm/assembler.h       |   16 +-
 kernel/arch/arm/include/asm/atomic.h          |   16 +-
 kernel/arch/arm/include/asm/bitops.h          |   24 +-
 kernel/arch/arm/include/asm/cmpxchg.h         |    8 +-
 kernel/arch/arm/include/asm/dovetail.h        |   61 +
 kernel/arch/arm/include/asm/efi.h             |    4 +
 kernel/arch/arm/include/asm/irq_pipeline.h    |  135 ++
 kernel/arch/arm/include/asm/irqflags.h        |   52 +-
 kernel/arch/arm/include/asm/mmu_context.h     |   40 +-
 kernel/arch/arm/include/asm/outercache.h      |    7 +-
 kernel/arch/arm/include/asm/ptrace.h          |    3 +
 kernel/arch/arm/include/asm/syscall.h         |    5 +
 kernel/arch/arm/include/asm/thread_info.h     |   20 +-
 .../arch/arm/include/asm/trace/exceptions.h   |   62 +
 .../arch/arm/include/asm/vdso/gettimeofday.h  |   60 +
 kernel/arch/arm/kernel/Makefile               |    5 +
 kernel/arch/arm/kernel/asm-offsets.c          |    4 +
 kernel/arch/arm/kernel/entry-armv.S           |   52 +-
 kernel/arch/arm/kernel/entry-common.S         |   79 +
 kernel/arch/arm/kernel/entry-header.S         |   23 +-
 kernel/arch/arm/kernel/irq.c                  |    9 +
 kernel/arch/arm/kernel/irq_pipeline.c         |   20 +
 kernel/arch/arm/kernel/patch.c                |    2 +-
 kernel/arch/arm/kernel/process.c              |   26 +
 kernel/arch/arm/kernel/ptrace.c               |    2 +
 kernel/arch/arm/kernel/raw_printk.c           |   30 +
 kernel/arch/arm/kernel/signal.c               |   34 +-
 kernel/arch/arm/kernel/smp.c                  |  121 +-
 kernel/arch/arm/kernel/smp_twd.c              |    7 +-
 kernel/arch/arm/kernel/traps.c                |    2 +-
 kernel/arch/arm/kernel/vdso.c                 |   51 +-
 kernel/arch/arm/mach-imx/gpc.c                |   21 +
 kernel/arch/arm/mm/alignment.c                |   21 +-
 kernel/arch/arm/mm/cache-l2x0.c               |   47 +-
 kernel/arch/arm/mm/context.c                  |   18 +-
 kernel/arch/arm/mm/fault.c                    |  109 +-
 kernel/arch/arm/vdso/datapage.S               |   11 +
 kernel/arch/arm/vfp/entry.S                   |    2 +
 kernel/arch/arm/vfp/vfphw.S                   |    2 +
 kernel/arch/arm/vfp/vfpmodule.c               |   54 +-
 kernel/arch/arm64/Kconfig                     |    4 +
 kernel/arch/arm64/boot/dts/broadcom/Makefile  |    1 +
 .../dts/broadcom/bcm2837-rpi-3-b-nobt.dts     |   12 +
 kernel/arch/arm64/include/asm/daifflags.h     |   14 +-
 kernel/arch/arm64/include/asm/dovetail.h      |   69 +
 kernel/arch/arm64/include/asm/efi.h           |    6 +
 kernel/arch/arm64/include/asm/fpsimd.h        |    1 +
 kernel/arch/arm64/include/asm/irq_pipeline.h  |  141 ++
 kernel/arch/arm64/include/asm/irqflags.h      |   46 +-
 kernel/arch/arm64/include/asm/mmu_context.h   |   34 +-
 kernel/arch/arm64/include/asm/ptrace.h        |    6 +
 kernel/arch/arm64/include/asm/syscall.h       |    5 +
 kernel/arch/arm64/include/asm/thread_info.h   |   21 +-
 kernel/arch/arm64/include/asm/uaccess.h       |    8 +-
 kernel/arch/arm64/include/asm/vdso.h          |    5 +
 .../arm64/include/asm/vdso/gettimeofday.h     |   65 +
 kernel/arch/arm64/kernel/Makefile             |    1 +
 kernel/arch/arm64/kernel/asm-offsets.c        |    1 +
 kernel/arch/arm64/kernel/debug-monitors.c     |    2 +-
 kernel/arch/arm64/kernel/entry-common.c       |  152 +-
 kernel/arch/arm64/kernel/entry.S              |   62 +-
 kernel/arch/arm64/kernel/fpsimd.c             |  196 +-
 kernel/arch/arm64/kernel/irq.c                |   10 +
 kernel/arch/arm64/kernel/irq_pipeline.c       |   23 +
 kernel/arch/arm64/kernel/process.c            |   36 +
 kernel/arch/arm64/kernel/signal.c             |   38 +-
 kernel/arch/arm64/kernel/smp.c                |  107 +-
 kernel/arch/arm64/kernel/syscall.c            |   20 +-
 kernel/arch/arm64/kernel/traps.c              |   36 +-
 kernel/arch/arm64/kernel/vdso.c               |   28 +-
 kernel/arch/arm64/kernel/vdso/vdso.lds.S      |    3 +
 kernel/arch/arm64/kernel/vdso32/vdso.lds.S    |    3 +
 kernel/arch/arm64/mm/context.c                |   11 +-
 kernel/arch/arm64/mm/fault.c                  |   40 +-
 kernel/arch/x86/Kconfig                       |    4 +
 kernel/arch/x86/entry/common.c                |   32 +
 kernel/arch/x86/entry/entry_64.S              |    5 +
 kernel/arch/x86/hyperv/hv_init.c              |    3 +-
 kernel/arch/x86/include/asm/apic.h            |    7 +-
 kernel/arch/x86/include/asm/dovetail.h        |   45 +
 kernel/arch/x86/include/asm/fpu/api.h         |   25 +-
 kernel/arch/x86/include/asm/fpu/internal.h    |   31 +-
 kernel/arch/x86/include/asm/fpu/types.h       |   12 +
 kernel/arch/x86/include/asm/i8259.h           |    2 +-
 kernel/arch/x86/include/asm/idtentry.h        |   93 +-
 kernel/arch/x86/include/asm/irq_pipeline.h    |  135 ++
 kernel/arch/x86/include/asm/irq_stack.h       |    7 +
 kernel/arch/x86/include/asm/irq_vectors.h     |   11 +-
 kernel/arch/x86/include/asm/irqflags.h        |   71 +-
 kernel/arch/x86/include/asm/mmu_context.h     |    7 +
 kernel/arch/x86/include/asm/pgtable.h         |    5 +-
 kernel/arch/x86/include/asm/special_insns.h   |    4 +-
 kernel/arch/x86/include/asm/syscall.h         |    5 +
 kernel/arch/x86/include/asm/thread_info.h     |   18 +
 kernel/arch/x86/include/asm/tlbflush.h        |    8 +-
 kernel/arch/x86/include/asm/uaccess.h         |    2 +-
 kernel/arch/x86/kernel/Makefile               |    1 +
 kernel/arch/x86/kernel/alternative.c          |   14 +-
 kernel/arch/x86/kernel/apic/apic.c            |   70 +-
 kernel/arch/x86/kernel/apic/apic_flat_64.c    |    4 +-
 kernel/arch/x86/kernel/apic/apic_numachip.c   |    4 +-
 kernel/arch/x86/kernel/apic/io_apic.c         |   85 +-
 kernel/arch/x86/kernel/apic/ipi.c             |   32 +-
 kernel/arch/x86/kernel/apic/msi.c             |   12 +-
 kernel/arch/x86/kernel/apic/vector.c          |   72 +-
 kernel/arch/x86/kernel/apic/x2apic_cluster.c  |    4 +-
 kernel/arch/x86/kernel/apic/x2apic_phys.c     |    4 +-
 kernel/arch/x86/kernel/asm-offsets.c          |    3 +
 kernel/arch/x86/kernel/cpu/acrn.c             |    3 +-
 kernel/arch/x86/kernel/cpu/mce/amd.c          |    7 +-
 kernel/arch/x86/kernel/cpu/mce/core.c         |    2 +
 kernel/arch/x86/kernel/cpu/mce/therm_throt.c  |    6 +-
 kernel/arch/x86/kernel/cpu/mce/threshold.c    |    2 +-
 kernel/arch/x86/kernel/cpu/mshyperv.c         |    6 +-
 kernel/arch/x86/kernel/cpu/mtrr/generic.c     |   12 +-
 kernel/arch/x86/kernel/dumpstack.c            |   12 +-
 kernel/arch/x86/kernel/fpu/core.c             |  111 +-
 kernel/arch/x86/kernel/fpu/signal.c           |   29 +-
 kernel/arch/x86/kernel/hpet.c                 |   10 +-
 kernel/arch/x86/kernel/i8259.c                |    3 +-
 kernel/arch/x86/kernel/idt.c                  |    4 +
 kernel/arch/x86/kernel/irq.c                  |   20 +-
 kernel/arch/x86/kernel/irq_pipeline.c         |  387 ++++
 kernel/arch/x86/kernel/irq_work.c             |    3 +-
 kernel/arch/x86/kernel/kvm.c                  |   17 +-
 kernel/arch/x86/kernel/nmi.c                  |    4 +
 kernel/arch/x86/kernel/process.c              |   16 +-
 kernel/arch/x86/kernel/process_64.c           |   32 +-
 kernel/arch/x86/kernel/smp.c                  |   15 +-
 kernel/arch/x86/kernel/smpboot.c              |    9 +-
 kernel/arch/x86/kernel/time.c                 |    2 +-
 kernel/arch/x86/kernel/traps.c                |  159 +-
 kernel/arch/x86/kernel/tsc.c                  |   19 +-
 kernel/arch/x86/kernel/tsc_sync.c             |    4 +
 kernel/arch/x86/kvm/emulate.c                 |   65 +-
 kernel/arch/x86/kvm/vmx/vmx.c                 |   37 +-
 kernel/arch/x86/kvm/x86.c                     |  106 +-
 kernel/arch/x86/lib/usercopy.c                |    2 +-
 kernel/arch/x86/mm/fault.c                    |  158 +-
 kernel/arch/x86/mm/tlb.c                      |   50 +-
 kernel/arch/x86/xen/Kconfig                   |    2 +-
 kernel/arch/x86/xen/enlighten_hvm.c           |    3 +-
 kernel/drivers/base/regmap/internal.h         |    5 +-
 kernel/drivers/base/regmap/regmap-irq.c       |    1 +
 kernel/drivers/base/regmap/regmap.c           |   41 +-
 kernel/drivers/clocksource/Kconfig            |    9 +-
 kernel/drivers/clocksource/arm_arch_timer.c   |   11 +-
 kernel/drivers/clocksource/arm_global_timer.c |   41 +-
 kernel/drivers/clocksource/bcm2835_timer.c    |   27 +-
 kernel/drivers/clocksource/clksrc_st_lpc.c    |    2 +-
 kernel/drivers/clocksource/dw_apb_timer.c     |   40 +-
 kernel/drivers/clocksource/exynos_mct.c       |   50 +-
 kernel/drivers/clocksource/mmio.c             |  503 ++++-
 kernel/drivers/clocksource/timer-imx-gpt.c    |    8 +-
 kernel/drivers/clocksource/timer-sun4i.c      |    5 +-
 .../clocksource/timer-ti-dm-systimer.c        |   29 +-
 kernel/drivers/cpuidle/cpuidle.c              |   18 +
 kernel/drivers/cpuidle/poll_state.c           |    2 +-
 kernel/drivers/dma/Kconfig                    |   18 +
 kernel/drivers/dma/bcm2835-dma.c              |  148 +-
 kernel/drivers/dma/dmaengine.c                |   10 +-
 kernel/drivers/dma/imx-sdma.c                 |  195 +-
 kernel/drivers/dma/virt-dma.c                 |  122 +-
 kernel/drivers/dma/virt-dma.h                 |  127 +-
 kernel/drivers/gpio/gpio-davinci.c            |    2 +-
 kernel/drivers/gpio/gpio-mxc.c                |    3 +-
 kernel/drivers/gpio/gpio-omap.c               |    6 +-
 kernel/drivers/gpio/gpio-pca953x.c            |    1 +
 kernel/drivers/gpio/gpio-pl061.c              |    3 +-
 kernel/drivers/gpio/gpio-xilinx.c             |   26 +-
 kernel/drivers/gpio/gpio-zynq.c               |    4 +-
 .../drivers/gpu/drm/msm/disp/dpu1/dpu_mdss.c  |    1 +
 .../drivers/gpu/drm/msm/disp/mdp5/mdp5_mdss.c |    3 +-
 kernel/drivers/gpu/ipu-v3/ipu-common.c        |    1 +
 kernel/drivers/iio/industrialio-trigger.c     |    1 +
 kernel/drivers/irqchip/exynos-combiner.c      |    7 +-
 kernel/drivers/irqchip/irq-bcm2835.c          |    3 +-
 kernel/drivers/irqchip/irq-bcm2836.c          |    3 +
 kernel/drivers/irqchip/irq-gic-v2m.c          |    3 +
 .../irqchip/irq-gic-v3-its-fsl-mc-msi.c       |    3 +-
 .../drivers/irqchip/irq-gic-v3-its-pci-msi.c  |    1 +
 .../irqchip/irq-gic-v3-its-platform-msi.c     |    1 +
 kernel/drivers/irqchip/irq-gic-v3-mbi.c       |    2 +-
 kernel/drivers/irqchip/irq-gic-v3.c           |    6 +-
 kernel/drivers/irqchip/irq-gic.c              |    5 +-
 kernel/drivers/irqchip/irq-imx-irqsteer.c     |    3 +-
 kernel/drivers/irqchip/irq-omap-intc.c        |    2 +-
 kernel/drivers/irqchip/irq-sun4i.c            |    2 +-
 kernel/drivers/irqchip/irq-sunxi-nmi.c        |    4 +-
 kernel/drivers/irqchip/irq-ti-sci-inta.c      |    2 +
 kernel/drivers/memory/omap-gpmc.c             |    3 +-
 kernel/drivers/mfd/tps65217.c                 |    1 +
 .../pci/controller/dwc/pcie-designware-host.c |    1 +
 kernel/drivers/pci/controller/pcie-brcmstb.c  |    2 +
 kernel/drivers/pinctrl/bcm/pinctrl-bcm2835.c  |    4 +-
 .../pinctrl/intel/pinctrl-cherryview.c        |    5 +-
 kernel/drivers/pinctrl/qcom/pinctrl-msm.c     |    5 +-
 .../drivers/pinctrl/samsung/pinctrl-exynos.c  |   23 +-
 .../drivers/pinctrl/samsung/pinctrl-samsung.c |   22 +-
 .../drivers/pinctrl/samsung/pinctrl-samsung.h |    2 +-
 kernel/drivers/pinctrl/sunxi/pinctrl-sunxi.c  |    5 +-
 kernel/drivers/pinctrl/sunxi/pinctrl-sunxi.h  |    2 +-
 kernel/drivers/soc/qcom/smp2p.c               |    1 +
 kernel/drivers/soc/ti/ti_sci_inta_msi.c       |    1 +
 kernel/drivers/spi/Kconfig                    |   11 +
 kernel/drivers/spi/spi-bcm2835.c              |   99 +-
 kernel/drivers/spi/spi.c                      |  295 ++-
 kernel/drivers/spmi/spmi-pmic-arb.c           |    4 +-
 kernel/drivers/tty/serial/8250/8250_core.c    |   45 +
 kernel/drivers/tty/serial/amba-pl011.c        |   39 +
 kernel/drivers/tty/serial/imx.c               |   48 +-
 kernel/drivers/tty/serial/samsung_tty.c       |    4 +
 kernel/drivers/tty/serial/st-asc.c            |   26 +
 kernel/fs/eventfd.c                           |   10 +-
 kernel/fs/exec.c                              |   14 +
 kernel/fs/fcntl.c                             |    2 +-
 kernel/fs/file.c                              |    8 +
 kernel/fs/ioctl.c                             |   16 +
 kernel/fs/udf/inode.c                         |   76 +-
 kernel/fs/udf/truncate.c                      |   48 +-
 kernel/include/asm-generic/atomic.h           |   12 +-
 kernel/include/asm-generic/cmpxchg-local.h    |    8 +-
 kernel/include/asm-generic/cmpxchg.h          |   16 +-
 kernel/include/asm-generic/irq_pipeline.h     |  109 +
 kernel/include/asm-generic/percpu.h           |   24 +-
 kernel/include/dovetail/irq.h                 |   11 +
 kernel/include/dovetail/mm_info.h             |   12 +
 kernel/include/dovetail/netdevice.h           |   13 +
 kernel/include/dovetail/poll.h                |   12 +
 kernel/include/dovetail/spinlock.h            |   21 +
 kernel/include/dovetail/thread_info.h         |   13 +
 kernel/include/linux/clockchips.h             |   71 +-
 kernel/include/linux/clocksource.h            |   52 +
 kernel/include/linux/console.h                |    1 +
 kernel/include/linux/context_tracking_state.h |    2 +-
 kernel/include/linux/dmaengine.h              |   41 +
 kernel/include/linux/dovetail.h               |  325 +++
 kernel/include/linux/dw_apb_timer.h           |    2 +-
 kernel/include/linux/entry-common.h           |   22 +-
 kernel/include/linux/fcntl.h                  |    2 +-
 kernel/include/linux/fs.h                     |   10 +
 kernel/include/linux/hardirq.h                |   18 +
 kernel/include/linux/intel-iommu.h            |    2 +-
 kernel/include/linux/interrupt.h              |   29 +-
 kernel/include/linux/irq.h                    |   50 +-
 kernel/include/linux/irq_pipeline.h           |  145 ++
 kernel/include/linux/irqdesc.h                |   27 +-
 kernel/include/linux/irqflags.h               |   37 +
 kernel/include/linux/irqstage.h               |  398 ++++
 kernel/include/linux/kernel.h                 |    8 +-
 kernel/include/linux/kvm_host.h               |   55 +
 kernel/include/linux/lockdep.h                |  115 +-
 kernel/include/linux/mm.h                     |    1 +
 kernel/include/linux/mm_types.h               |    5 +
 kernel/include/linux/net.h                    |    1 +
 kernel/include/linux/netdevice.h              |   94 +
 kernel/include/linux/poll.h                   |    1 +
 kernel/include/linux/preempt.h                |   57 +-
 kernel/include/linux/printk.h                 |   17 +-
 kernel/include/linux/rcupdate.h               |   14 +-
 kernel/include/linux/regmap.h                 |    1 +
 kernel/include/linux/sched.h                  |   10 +
 kernel/include/linux/sched/coredump.h         |    1 +
 kernel/include/linux/skbuff.h                 |   69 +
 kernel/include/linux/smp.h                    |   15 +
 kernel/include/linux/socket.h                 |    4 +-
 kernel/include/linux/spi/spi.h                |   99 +
 kernel/include/linux/spinlock.h               |   98 +-
 kernel/include/linux/spinlock_api_up.h        |   18 +
 kernel/include/linux/spinlock_pipeline.h      |  387 ++++
 kernel/include/linux/spinlock_types.h         |  154 ++
 kernel/include/linux/stop_machine.h           |    3 +
 kernel/include/linux/thread_info.h            |   66 +
 kernel/include/linux/tick.h                   |    8 +
 kernel/include/linux/tracepoint.h             |    6 +-
 kernel/include/linux/vmalloc.h                |    1 +
 kernel/include/linux/wakeup_reason.h          |    2 +-
 kernel/include/net/netoob.h                   |   17 +
 kernel/include/net/sock.h                     |    3 +
 kernel/include/trace/events/irq.h             |   42 +
 kernel/include/uapi/asm-generic/dovetail.h    |    7 +
 kernel/include/uapi/asm-generic/fcntl.h       |    9 +
 kernel/include/uapi/linux/clocksource.h       |   33 +
 kernel/include/vdso/datapage.h                |   25 +
 kernel/init/Kconfig                           |   14 +-
 kernel/init/Makefile                          |    2 +-
 kernel/init/main.c                            |    8 +-
 kernel/kernel/Kconfig.dovetail                |   23 +
 kernel/kernel/Makefile                        |    1 +
 kernel/kernel/debug/debug_core.c              |   19 +-
 kernel/kernel/dovetail.c                      |  450 +++++
 kernel/kernel/entry/common.c                  |  196 +-
 kernel/kernel/exit.c                          |    2 +
 kernel/kernel/fork.c                          |    6 +
 kernel/kernel/irq/Kconfig                     |   13 +
 kernel/kernel/irq/Makefile                    |    2 +
 kernel/kernel/irq/chip.c                      |  269 ++-
 kernel/kernel/irq/cpuhotplug.c                |    5 +
 kernel/kernel/irq/debug.h                     |    2 +
 kernel/kernel/irq/dummychip.c                 |    4 +-
 kernel/kernel/irq/generic-chip.c              |    2 +-
 kernel/kernel/irq/handle.c                    |    9 +-
 kernel/kernel/irq/internals.h                 |    2 +
 kernel/kernel/irq/irqdesc.c                   |    9 +-
 kernel/kernel/irq/irqptorture.c               |  254 +++
 kernel/kernel/irq/manage.c                    |   89 +-
 kernel/kernel/irq/msi.c                       |    3 +
 kernel/kernel/irq/pipeline.c                  | 1764 +++++++++++++++++
 kernel/kernel/irq/proc.c                      |    3 +
 kernel/kernel/irq/resend.c                    |    8 +-
 kernel/kernel/irq/settings.h                  |   34 +
 kernel/kernel/irq_work.c                      |    9 +-
 kernel/kernel/kthread.c                       |    4 +
 kernel/kernel/locking/Makefile                |    1 +
 kernel/kernel/locking/lockdep.c               |  213 +-
 kernel/kernel/locking/lockdep_internals.h     |    4 +-
 kernel/kernel/locking/pipeline.c              |  231 +++
 kernel/kernel/locking/spinlock_debug.c        |    3 +
 kernel/kernel/notifier.c                      |    3 +
 kernel/kernel/panic.c                         |   26 +-
 kernel/kernel/power/Makefile                  |    2 +
 kernel/kernel/power/hibernate.c               |    3 +
 kernel/kernel/printk/printk.c                 |   73 +
 kernel/kernel/printk/printk_safe.c            |    3 +
 kernel/kernel/ptrace.c                        |    2 +
 kernel/kernel/rcu/tree.c                      |   31 +-
 kernel/kernel/rcu/tree_plugin.h               |    2 +-
 kernel/kernel/rcu/update.c                    |   31 +
 kernel/kernel/sched/core.c                    |  321 ++-
 kernel/kernel/sched/idle.c                    |   22 +-
 kernel/kernel/sched/sched.h                   |    2 +
 kernel/kernel/sched/wait.c                    |    2 +
 kernel/kernel/signal.c                        |   12 +-
 kernel/kernel/stop_machine.c                  |    4 +-
 kernel/kernel/time/Makefile                   |    1 +
 kernel/kernel/time/clockevents.c              |   77 +-
 kernel/kernel/time/clocksource.c              |   30 +-
 kernel/kernel/time/hrtimer.c                  |    1 +
 kernel/kernel/time/tick-broadcast.c           |   17 +
 kernel/kernel/time/tick-common.c              |   19 +-
 kernel/kernel/time/tick-internal.h            |   15 +-
 kernel/kernel/time/tick-proxy.c               |  466 +++++
 kernel/kernel/time/vsyscall.c                 |   31 +-
 kernel/kernel/trace/ftrace.c                  |   18 +-
 kernel/kernel/trace/ring_buffer.c             |   18 +-
 kernel/kernel/trace/trace.c                   |   16 +-
 kernel/kernel/trace/trace.h                   |    7 +-
 kernel/kernel/trace/trace_branch.c            |    4 +-
 kernel/kernel/trace/trace_clock.c             |    4 +-
 kernel/kernel/trace/trace_functions.c         |    4 +-
 kernel/kernel/trace/trace_functions_graph.c   |    8 +-
 kernel/kernel/trace/trace_irqsoff.c           |   11 +-
 kernel/kernel/trace/trace_output.c            |    9 +-
 kernel/kernel/trace/trace_preemptirq.c        |   52 +
 kernel/kernel/trace/trace_sched_wakeup.c      |    2 +
 kernel/kernel/trace/trace_stack.c             |    5 +-
 kernel/lib/Kconfig.debug                      |   53 +
 kernel/lib/atomic64.c                         |   24 +-
 kernel/lib/dump_stack.c                       |   36 +-
 kernel/lib/smp_processor_id.c                 |    4 +
 kernel/lib/vdso/Kconfig                       |    8 +
 kernel/lib/vdso/gettimeofday.c                |  286 ++-
 kernel/mm/ioremap.c                           |    1 +
 kernel/mm/kasan/report.c                      |    6 +-
 kernel/mm/memory.c                            |   18 +
 kernel/mm/mprotect.c                          |    4 +-
 kernel/mm/vmalloc.c                           |    6 +
 kernel/net/Kconfig                            |    3 +
 kernel/net/core/dev.c                         |   98 +-
 kernel/net/core/net-sysfs.c                   |   52 +
 kernel/net/core/skbuff.c                      |  115 ++
 kernel/net/packet/af_packet.c                 |    1 +
 kernel/net/sched/Kconfig                      |   23 +
 kernel/net/sched/Makefile                     |    1 +
 kernel/net/sched/sch_oob.c                    |  294 +++
 kernel/net/socket.c                           |  127 +-
 kernel/scripts/mkcompile_h                    |    6 +-
 kernel/security/selinux/hooks.c               |    4 +-
 kernel/security/selinux/include/classmap.h    |    4 +-
 .../perf/trace/beauty/include/linux/socket.h  |    3 +-
 385 files changed, 14720 insertions(+), 1414 deletions(-)
 create mode 100644 kernel/Documentation/dovetail.rst
 create mode 100644 kernel/arch/arm/include/asm/dovetail.h
 create mode 100644 kernel/arch/arm/include/asm/irq_pipeline.h
 create mode 100644 kernel/arch/arm/include/asm/trace/exceptions.h
 create mode 100644 kernel/arch/arm/kernel/irq_pipeline.c
 create mode 100644 kernel/arch/arm/kernel/raw_printk.c
 create mode 100644 kernel/arch/arm64/boot/dts/broadcom/bcm2837-rpi-3-b-nobt.dts
 create mode 100644 kernel/arch/arm64/include/asm/dovetail.h
 create mode 100644 kernel/arch/arm64/include/asm/irq_pipeline.h
 create mode 100644 kernel/arch/arm64/kernel/irq_pipeline.c
 create mode 100644 kernel/arch/x86/include/asm/dovetail.h
 create mode 100644 kernel/arch/x86/include/asm/irq_pipeline.h
 create mode 100644 kernel/arch/x86/kernel/irq_pipeline.c
 create mode 100644 kernel/include/asm-generic/irq_pipeline.h
 create mode 100644 kernel/include/dovetail/irq.h
 create mode 100644 kernel/include/dovetail/mm_info.h
 create mode 100644 kernel/include/dovetail/netdevice.h
 create mode 100644 kernel/include/dovetail/poll.h
 create mode 100644 kernel/include/dovetail/spinlock.h
 create mode 100644 kernel/include/dovetail/thread_info.h
 create mode 100644 kernel/include/linux/dovetail.h
 create mode 100644 kernel/include/linux/irq_pipeline.h
 create mode 100644 kernel/include/linux/irqstage.h
 create mode 100644 kernel/include/linux/spinlock_pipeline.h
 create mode 100644 kernel/include/net/netoob.h
 create mode 100644 kernel/include/uapi/asm-generic/dovetail.h
 create mode 100644 kernel/include/uapi/linux/clocksource.h
 create mode 100644 kernel/kernel/Kconfig.dovetail
 create mode 100644 kernel/kernel/dovetail.c
 create mode 100644 kernel/kernel/irq/irqptorture.c
 create mode 100644 kernel/kernel/irq/pipeline.c
 create mode 100644 kernel/kernel/locking/pipeline.c
 create mode 100644 kernel/kernel/time/tick-proxy.c
 create mode 100644 kernel/net/sched/sch_oob.c

diff --git a/kernel/Makefile b/kernel/Makefile
index 49d1d03a89..4a2ca05ddf 100644
--- a/kernel/Makefile
+++ b/kernel/Makefile
@@ -1,7 +1,7 @@
 # SPDX-License-Identifier: GPL-2.0
 VERSION = 5
 PATCHLEVEL = 10
-SUBLEVEL = 160
+SUBLEVEL = 161
 EXTRAVERSION =
 NAME = Dare mighty things
 
diff --git a/kernel/arch/Kconfig b/kernel/arch/Kconfig
index c3a40c57f4..42eb62fb7e 100644
--- a/kernel/arch/Kconfig
+++ b/kernel/arch/Kconfig
@@ -229,6 +229,9 @@ config HAVE_FUNCTION_ERROR_INJECTION
 config HAVE_NMI
 	bool
 
+config HAVE_PERCPU_PREEMPT_COUNT
+	bool
+
 #
 # An arch should select this if it provides all these things:
 #
diff --git a/kernel/arch/arm/Kconfig b/kernel/arch/arm/Kconfig
index f6ce22c95c..57afcf1801 100644
--- a/kernel/arch/arm/Kconfig
+++ b/kernel/arch/arm/Kconfig
@@ -236,6 +236,11 @@ config NEED_RET_TO_USER
 config ARCH_MTD_XIP
 	bool
 
+# Limited I-pipe compat (syscall routing only).
+config IPIPE_COMPAT
+	bool
+	select DOVETAIL_LEGACY_SYSCALL_RANGE
+
 config ARM_PATCH_PHYS_VIRT
 	bool "Patch physical to virtual translations at runtime" if EMBEDDED
 	default y
@@ -585,6 +590,8 @@ config ARCH_MULTI_V7
 config ARCH_MULTI_V6_V7
 	bool
 	select MIGHT_HAVE_CACHE_L2X0
+	select HAVE_IRQ_PIPELINE
+	select HAVE_DOVETAIL if CPU_HAS_ASID
 
 config ARCH_MULTI_CPU_AUTO
 	def_bool !(ARCH_MULTI_V4 || ARCH_MULTI_V4T || ARCH_MULTI_V6_V7)
@@ -1237,6 +1244,8 @@ config SCHED_SMT
 	  MultiThreading at a cost of slightly increased overhead in some
 	  places. If unsure say N here.
 
+source "kernel/Kconfig.dovetail"
+
 config HAVE_ARM_SCU
 	bool
 	help
diff --git a/kernel/arch/arm/common/mcpm_entry.c b/kernel/arch/arm/common/mcpm_entry.c
index 8a9aeeb504..53c3be5266 100644
--- a/kernel/arch/arm/common/mcpm_entry.c
+++ b/kernel/arch/arm/common/mcpm_entry.c
@@ -206,7 +206,7 @@ int mcpm_cpu_power_up(unsigned int cpu, unsigned int cluster)
 	 * Since this is called with IRQs enabled, and no arch_spin_lock_irq
 	 * variant exists, we need to disable IRQs manually here.
 	 */
-	local_irq_disable();
+	hard_local_irq_disable();
 	arch_spin_lock(&mcpm_lock);
 
 	cpu_is_down = !mcpm_cpu_use_count[cluster][cpu];
@@ -230,7 +230,7 @@ int mcpm_cpu_power_up(unsigned int cpu, unsigned int cluster)
 		ret = platform_ops->cpu_powerup(cpu, cluster);
 
 	arch_spin_unlock(&mcpm_lock);
-	local_irq_enable();
+	hard_local_irq_enable();
 	return ret;
 }
 
@@ -349,7 +349,7 @@ int mcpm_cpu_powered_up(void)
 	mpidr = read_cpuid_mpidr();
 	cpu = MPIDR_AFFINITY_LEVEL(mpidr, 0);
 	cluster = MPIDR_AFFINITY_LEVEL(mpidr, 1);
-	local_irq_save(flags);
+	flags = hard_local_irq_save();
 	arch_spin_lock(&mcpm_lock);
 
 	cpu_was_down = !mcpm_cpu_use_count[cluster][cpu];
@@ -363,7 +363,7 @@ int mcpm_cpu_powered_up(void)
 		platform_ops->cpu_is_up(cpu, cluster);
 
 	arch_spin_unlock(&mcpm_lock);
-	local_irq_restore(flags);
+	hard_local_irq_restore(flags);
 
 	return 0;
 }
@@ -402,7 +402,7 @@ int __init mcpm_loopback(void (*cache_disable)(void))
 	 * infrastructure. Let's play it safe by using cpu_pm_enter()
 	 * in case the CPU init code path resets the VFP or similar.
 	 */
-	local_irq_disable();
+	hard_local_irq_disable();
 	local_fiq_disable();
 	ret = cpu_pm_enter();
 	if (!ret) {
@@ -410,7 +410,7 @@ int __init mcpm_loopback(void (*cache_disable)(void))
 		cpu_pm_exit();
 	}
 	local_fiq_enable();
-	local_irq_enable();
+	hard_local_irq_enable();
 	if (ret)
 		pr_err("%s returned %d\n", __func__, ret);
 	return ret;
diff --git a/kernel/arch/arm/include/asm/assembler.h b/kernel/arch/arm/include/asm/assembler.h
index 8ff20f9b06..e2df9c4b2e 100644
--- a/kernel/arch/arm/include/asm/assembler.h
+++ b/kernel/arch/arm/include/asm/assembler.h
@@ -122,7 +122,7 @@
 	.if \save
 	stmdb   sp!, {r0-r3, ip, lr}
 	.endif
-	bl	trace_hardirqs_off
+	bl	trace_hardirqs_off_pipelined
 	.if \save
 	ldmia	sp!, {r0-r3, ip, lr}
 	.endif
@@ -138,13 +138,25 @@
 	.if \save
 	stmdb   sp!, {r0-r3, ip, lr}
 	.endif
-	bl\cond	trace_hardirqs_on
+	bl\cond	trace_hardirqs_on_pipelined
 	.if \save
 	ldmia	sp!, {r0-r3, ip, lr}
 	.endif
 #endif
 	.endm
 
+	.macro  disable_irq_if_pipelined
+#ifdef CONFIG_IRQ_PIPELINE
+	disable_irq_notrace
+#endif
+	.endm
+
+	.macro  enable_irq_if_pipelined
+#ifdef CONFIG_IRQ_PIPELINE
+	enable_irq_notrace
+#endif
+	.endm
+
 	.macro disable_irq, save=1
 	disable_irq_notrace
 	asm_trace_hardirqs_off \save
diff --git a/kernel/arch/arm/include/asm/atomic.h b/kernel/arch/arm/include/asm/atomic.h
index 455eb19a5a..0cf92e56d0 100644
--- a/kernel/arch/arm/include/asm/atomic.h
+++ b/kernel/arch/arm/include/asm/atomic.h
@@ -164,9 +164,9 @@ static inline void atomic_##op(int i, atomic_t *v)			\
 {									\
 	unsigned long flags;						\
 									\
-	raw_local_irq_save(flags);					\
+	flags = hard_local_irq_save();					\
 	v->counter c_op i;						\
-	raw_local_irq_restore(flags);					\
+	hard_local_irq_restore(flags);					\
 }									\
 
 #define ATOMIC_OP_RETURN(op, c_op, asm_op)				\
@@ -175,10 +175,10 @@ static inline int atomic_##op##_return(int i, atomic_t *v)		\
 	unsigned long flags;						\
 	int val;							\
 									\
-	raw_local_irq_save(flags);					\
+	flags = hard_local_irq_save();					\
 	v->counter c_op i;						\
 	val = v->counter;						\
-	raw_local_irq_restore(flags);					\
+	hard_local_irq_restore(flags);					\
 									\
 	return val;							\
 }
@@ -189,10 +189,10 @@ static inline int atomic_fetch_##op(int i, atomic_t *v)			\
 	unsigned long flags;						\
 	int val;							\
 									\
-	raw_local_irq_save(flags);					\
+	flags = hard_local_irq_save();					\
 	val = v->counter;						\
 	v->counter c_op i;						\
-	raw_local_irq_restore(flags);					\
+	hard_local_irq_restore(flags);					\
 									\
 	return val;							\
 }
@@ -202,11 +202,11 @@ static inline int atomic_cmpxchg(atomic_t *v, int old, int new)
 	int ret;
 	unsigned long flags;
 
-	raw_local_irq_save(flags);
+	flags = hard_local_irq_save();
 	ret = v->counter;
 	if (likely(ret == old))
 		v->counter = new;
-	raw_local_irq_restore(flags);
+	hard_local_irq_restore(flags);
 
 	return ret;
 }
